/* global angular, goog, vitisApp, bootbox */

//bloque les delete du destructeur à éviter
//'use strict';

console.info("Generateur_wab_generator_1 loaded --> your functions are ready");
/***********************************************************************************
 Signaletique_Recap_0 Javascript
 ***********************************************************************************/

var oFormRequired = {
    "sUrl": "",
    "scope_": {},
    "toDestructor": []
};
/**
 * constructor_form
 * Fonction appelé à l'initialisation du formulaire si dans la structure json javascript vaut "true"
 * @param {type} scope
 * @param {type} s_url
 * @returns {undefined}
 */
var constructor_form = function (scope, s_url) {
    //////////////////////////////////////////////////////////
    //Ne pas toucher
    console.log("Constructor");
    
    oFormRequired.sUrl = s_url;
    oFormRequired.scope_ = scope;
    //console.log(scope);
    //////////////////////////////////////////////////////////
    // Permet de recharge le javascript d'une section à une autre
    var envSrvc = angular.element(vitisApp.appWorkspaceListDrtv).injector().get(["envSrvc"]);
    var formSrvc = angular.element(vitisApp.appMainDrtv).injector().get(["formSrvc"]);
    var propertiesSrvc = angular.element(vitisApp.appMainDrtv).injector().get(["propertiesSrvc"]);
    
    /*oFormRequired.toDestructor.push(oFormRequired.scope_.$watch("oFormValues." + oFormRequired.scope_.sFormDefinitionName + ".btn_refresh_treeview", function (value) {
        console.log("DJFHVHJCHSJCJH");
    }*/
    
    /**
     * loadTreeview function.
     * Crée le treeview des fichiers du projet fme.
     **/
    scope["loadTreeviewDepot"] = function() {
        var $log = angular.element(vitisApp.appMainDrtv).injector().get(["$log"]);
        //
        $log.info("loadTreeviewDepot");
        
        // Charge l'arborescence des logs.
        ajaxRequest({
            "method": "GET",
            "url": propertiesSrvc["web_server_name"] + "/" + propertiesSrvc["services_alias"] + "/extraction/extraction_depots/Tree",
            "scope": scope,
            "success": function(response) {
                if (response["data"]["status"] == 1) {
                    var aNodes = [];
                    data = response["data"]["tree"];
                    scope["aSelectedWorkspaceFile"] = [];
                    scope["aTreeviewLogs"] = data;
                    // Crée l'arborescence dans l'élément.
                    
                    for (var i in response["data"]["content"]) {
                        var aNode = {"text": response["data"]["content"][i]["filename"].split("/").pop(), "nodes": []}
                        for (var j in response["data"]["content"][i]["content"]) {
                            aNode["nodes"].push({"text": response["data"]["content"][i]["content"][j]["filename"].split("/").pop(), "tags": response["data"]["content"][i]["content"][j]["lastModification"].split(),});
                        }
                        aNodes.push(aNode);
                    }
                    
                    $("#Element_0_2_1_treeview")["treeview"]({
                        "showBorder": false,
                        "expandIcon": "glyphicon glyphicon-folder-close",
                        "collapseIcon": "glyphicon glyphicon-folder-open",
                        "highlightSelected": true,
                        "multiSelect": false,
                        "showTags": true,
                        "data": aNodes
                    });
                }
            }
        });
    };
    
    scope["deleteFileDepot"] = function () {
        var $log = angular.element(vitisApp.appMainDrtv).injector().get(["$log"]);
        //
        $log.info("deleteFileDepot");
        
        var aSelectedNode = $("#Element_0_2_1_treeview")["treeview"]('getSelected')
        
        if (aSelectedNode.length > 0)
        {       
            var aNodeParent = $("#Element_0_2_1_treeview")["treeview"]('getNode', aSelectedNode[0]["parentId"]);
            ajaxRequest({
                "method": "DELETES",
                "params": {
                        "file_name": aNodeParent["text"] + "/" + aSelectedNode[0]["text"]
                    },
                "url": propertiesSrvc["web_server_name"] + "/" + propertiesSrvc["services_alias"] + "/extraction/extraction_depots",
                "scope": scope,
                "success": function(response) {
                    if (response["data"]["status"] == 1) {
                    }
                }
            });
            scope["loadTreeviewDepot"]();
        }
        else
        {
            var sErrorMessage = "EXTRACTION_DEPOT_DELETE_SELECT_A_FILE";
            var oOptions = {
                "className": "modal-danger",
                "message": sErrorMessage
            };
            //$('#myModal').modal('toggle');
            scope.$root["modalWindow"]("dialog", "EXTRACTION_DEPORT_DELETE_NO_SELECTED", oOptions);
            //$('#myModal').modal('hide');
        }
        
    }
    scope["loadTreeviewDepot"]();
    
    scope["downloadFileDepot"] = function () {
        var $log = angular.element(vitisApp.appMainDrtv).injector().get(["$log"]);
        //
        $log.info("downloadFileDepot");
        
        var aSelectedNode = $("#Element_0_2_1_treeview")["treeview"]('getSelected');
        var sFileName = aSelectedNode[0]["text"];
        var aNodeParent = $("#Element_0_2_1_treeview")["treeview"]('getNode', aSelectedNode[0]["parentId"]);
        if (aSelectedNode[0]["parentId"] == "")
        {
            if (sFileName != "")
            {
                ajaxRequest({
                    "method": "GET",
                    "url": propertiesSrvc["web_server_name"] + "/" + propertiesSrvc["services_alias"] + "/extraction/extraction_depots/File",
                    "scope": scope,
                    "params": {
                        "file_name": aNodeParent["text"] + "/" + aSelectedNode[0]["text"]
                    },
                    "responseType": 'blob',
                    "success": function(response) {
                        if (typeof(window.navigator.msSaveOrOpenBlob) == "undefined") {
                            // Crée un lien et simule un click dessus.
                            var link = document.createElement('a');
                            link.href = window.URL.createObjectURL(response["data"]);
                            link.download = sFileName;
                            link.style.display = 'none';
                            document.body.appendChild(link);
                            link.click();
                            document.body.removeChild(link);
                        }
                        else {
                            // Pour Edge et IE.
                            window.navigator.msSaveOrOpenBlob(response["data"], sFileName);
                        }
                    }
                });
            }
        }
    }
    //var iMaxUploadFileSize = parseInt(propertiesSrvc["max_upload_file_size"]);
    
    /**
     * beforeProjectDirectory function.
     * Traitement avant l'envoi du formulaire de la section "Répertoire Projet" (publication > Projet FME).
     */
    angular.element(vitisApp.appMainDrtv).scope()["beforeDepositDirectory"] = function () {
        // Injection des services.
        var $log = angular.element(vitisApp.appMainDrtv).injector().get(["$log"]);
        var $q = angular.element(vitisApp.appHtmlFormDrtv).injector().get(["$q"]);
        var envSrvc = angular.element(vitisApp.appMainDrtv).injector().get(["envSrvc"]);
        var propertiesSrvc = angular.element(vitisApp.appMainDrtv).injector().get(["propertiesSrvc"]);
        //
        $log.info("beforeDepositDirectory");
        envSrvc.sMode = "update";
        var scope = this;
        var deferred = $q.defer();
        var promise = deferred.promise;
        //
        var oFile = envSrvc["oFormValues"][envSrvc["sFormDefinitionName"]]["control_file"];
        var iMaxUploadFileSize = parseInt(propertiesSrvc["max_upload_file_size"]);
        var sErrorMessage;

        // Vérification du fichier .fmw.
        if (typeof (oFile) === "object" && typeof (oFile["aFiles"]) !== "undefined" && oFile["aFiles"].length > 0) {
                // Taille maxi du fichier.
                if (oFile["aFiles"][0]["size"] > iMaxUploadFileSize)
                    sErrorMessage = "ERROR_FILE_SIZE_EXTRACTION_LOAD_DEPOSIT_DIRECTORY";
        }
        // Validation du formulaire.
        if (typeof (sErrorMessage) === "undefined")
            deferred.resolve();

        // Affichage de la fenêtre modale d'erreur.
        if (typeof (sErrorMessage) !== "undefined") {
            var oOptions = {
                "className": "modal-danger",
                "message": sErrorMessage
            };
            scope.$root["modalWindow"]("dialog", "FORM_VALIDATION_ERROR", oOptions);
        }
        //
        return promise;
    };
    
    /**
     * afterProjectDirectory function.
     * Actions à effectuer après l'upload d'un fichier dans le répertoire d'un projet fme.
     */
    angular.element(vitisApp.appMainDrtv).scope()["afterDepositDirectory"] = function () {
        // Injection des services.
        var $log = angular.element(vitisApp.appMainDrtv).injector().get(["$log"]);
        //
        $log.info("afterDepositDirectory");
        // Remise à zéro du formulaire.
        this["resetForm"]();
        angular.element("input[type=file]")["fileinput"]("clear");
        // Recharge la liste des fichiers.
        this["loadTreeviewDepot"]();
    }
    //
};


/**
 * destructor_form
 * Fonction appelé quand on quitte le formulaire nettoie toute les fonctions pour les rendres inutilisable en dehors du formulaire
 * @returns {undefined}
 */
var destructor_form = function () {
    console.log("Destructor");
    
    for (var i = 0; i < oFormRequired.toDestructor.length; i++) {
        oFormRequired.toDestructor[i] = undefined;
        delete oFormRequired.toDestructor[i];
    }
    
    //supprimer la balise script du js pour pouvoir le recharger si on reviens sur le formulaire plus tard
    angular.element('[src="' + oFormRequired.sUrl + '?version=' + oFormRequired.scope_["oProperties"]["build"] + '"]').remove();
    
    oFormRequired = undefined;
    delete oFormRequired;
    
    constructor_form = undefined;
    delete constructor_form;
    destructor_form = undefined;
    delete destructor_form;
};

/**********************************************************************************/